// tablib for lua algebra fx2.
// less fonctions there are, faster is lua,
// so only useful fonctions are include (garbage collector patch already done)

/*
** $Id: ltablib.c,v 1.38.1.3 2008/02/14 16:46:58 roberto Exp $
** Library for Table Manipulation
** See Copyright Notice in lua.h
*/




#define ltablib_c
#define LUA_LIB

//#include "lua.h"


//#include "lualib.h"







//////////////////////////

 #define LUA_TABLIBNAME	"table"
#define aux_getn(L,n)	(luaL_checktype(L, n, LUA_TTABLE), luaL_getn(L, n))
  /*
static int foreachi (lua_State *L) {
  int i;
  int n = aux_getn(L, 1);
  luaL_checktype(L, 2, LUA_TFUNCTION);
  for (i=1; i <= n; i++) {
    lua_pushvalue(L, 2);
    lua_pushinteger(L, i);
    lua_rawgeti(L, 1, i);
    lua_call(L, 2, 1);
    if (!lua_isnil(L, -1))
      return 1;
    lua_pop(L, 1);
  }
  return 0;
}


static int foreach (lua_State *L) {
  luaL_checktype(L, 1, LUA_TTABLE);
  luaL_checktype(L, 2, LUA_TFUNCTION);
  lua_pushnil(L);
  while (lua_next(L, 1)) {
    lua_pushvalue(L, 2);
    lua_pushvalue(L, -3);
    lua_pushvalue(L, -3);
    lua_call(L, 2, 1);
    if (!lua_isnil(L, -1))
      return 1;
    lua_pop(L, 2);
  }
  return 0;
}                    */


static int maxn (lua_State *L) {
  lua_Number max = 0;
  luaL_checktype(L, 1, LUA_TTABLE);
  lua_pushnil(L);  /* first key */
  while (lua_next(L, 1)) {
    lua_pop(L, 1);  /* remove value */
    if (lua_type(L, -1) == LUA_TNUMBER) {
      lua_Number v = lua_tonumber(L, -1);
      if (v > max) max = v;
    }
  }
  lua_pushnumber(L, max);
  return 1;
}


static int getn (lua_State *L) {
  lua_pushinteger(L, aux_getn(L, 1));
  return 1;
}


static int setn (lua_State *L) {
  luaL_checktype(L, 1, LUA_TTABLE);
#ifndef luaL_setn
  luaL_setn(L, 1, luaL_checkint(L, 2));
#else
  luaL_error(L, LUA_QL("setn") " is obsolete");
#endif
  lua_pushvalue(L, 1);
  return 1;
}


static int tinsert (lua_State *L) {
  int e = aux_getn(L, 1) + 1;  /* first empty element */
  int pos;  /* where to insert new element */
  switch (lua_gettop(L)) {
    case 2: {  /* called with only 2 arguments */
      pos = e;  /* insert new element at the end */
      break;
    }
    case 3: {
      int i;
      pos = luaL_checkint(L, 2);  /* 2nd argument is the position */
      if (pos > e) e = pos;  /* `grow' array if necessary */
      for (i = e; i > pos; i--) {  /* move up elements */
        lua_rawgeti(L, 1, i-1);
        lua_rawseti(L, 1, i);  /* t[i] = t[i-1] */
      }
      break;
    }
    default: {
      return luaL_error(L, "wrong number of arguments to " LUA_QL("insert"));
    }
  }
  luaL_setn(L, 1, e);  /* new size */
  lua_rawseti(L, 1, pos);  /* t[pos] = v */
  return 0;
}


static int tremove (lua_State *L) {
  int e = aux_getn(L, 1);
  int pos = luaL_optint(L, 2, e);
  if (!(1 <= pos && pos <= e))  /* position is outside bounds? */
   return 0;  /* nothing to remove */
  luaL_setn(L, 1, e - 1);  /* t.n = n-1 */
  lua_rawgeti(L, 1, pos);  /* result = t[pos] */
  for ( ;pos<e; pos++) {
    lua_rawgeti(L, 1, pos+1);
    lua_rawseti(L, 1, pos);  /* t[pos] = t[pos+1] */
  }
  lua_pushnil(L);
  lua_rawseti(L, 1, e);  /* t[e] = nil */
  return 1;
}

            /*
static void addfield (lua_State *L, luaL_Buffer *b, int i) {
  lua_rawgeti(L, 1, i);
  if (!lua_isstring(L, -1))
    luaL_error(L, "invalid value (%s) at index %d in table for "
                  LUA_QL("concat"), luaL_typename(L, -1), i);
    luaL_addvalue(b);
}


static int tconcat (lua_State *L) {
  luaL_Buffer b;
  size_t lsep;
  int i, last;
  const char *sep = luaL_optlstring(L, 2, "", &lsep);
  luaL_checktype(L, 1, LUA_TTABLE);
  i = luaL_optint(L, 3, 1);
  last = luaL_opt(L, luaL_checkint, 4, luaL_getn(L, 1));
  luaL_buffinit(L, &b);
  for (; i < last; i++) {
    addfield(L, &b, i);
    luaL_addlstring(&b, sep, lsep);
  }
  if (i == last)
    addfield(L, &b, i);
  luaL_pushresult(&b);
  return 1;
}                                 */



/*
** {======================================================
** Quicksort
** (based on `Algorithms in MODULA-3', Robert Sedgewick;
**  Addison-Wesley, 1993.)
*/

                         /*
static void set2 (lua_State *L, int i, int j) {
  lua_rawseti(L, 1, i);
  lua_rawseti(L, 1, j);
}

static int sort_comp (lua_State *L, int a, int b) {
  if (!lua_isnil(L, 2)) {
    int res;
    lua_pushvalue(L, 2);
    lua_pushvalue(L, a-1);
    lua_pushvalue(L, b-2);
    lua_call(L, 2, 1);
    res = lua_toboolean(L, -1);
    lua_pop(L, 1);
    return res;
  }
  else
    return lua_lessthan(L, a, b);
}

static void auxsort (lua_State *L, int l, int u) {
  while (l < u) {
    int i, j;

    lua_rawgeti(L, 1, l);
    lua_rawgeti(L, 1, u);
    if (sort_comp(L, -1, -2))
      set2(L, l, u);
    else
      lua_pop(L, 2);
    if (u-l == 1) break;
    i = (l+u)/2;
    lua_rawgeti(L, 1, i);
    lua_rawgeti(L, 1, l);
    if (sort_comp(L, -2, -1))
      set2(L, i, l);
    else {
      lua_pop(L, 1);
      lua_rawgeti(L, 1, u);
      if (sort_comp(L, -1, -2))
        set2(L, i, u);
      else
        lua_pop(L, 2);
    }
    if (u-l == 2) break;
    lua_rawgeti(L, 1, i);
    lua_pushvalue(L, -1);
    lua_rawgeti(L, 1, u-1);
    set2(L, i, u-1);

    i = l; j = u-1;
    for (;;) {

      while (lua_rawgeti(L, 1, ++i), sort_comp(L, -1, -2)) {
        if (i>u) luaL_error(L, "invalid order function for sorting");
        lua_pop(L, 1);
      }

      while (lua_rawgeti(L, 1, --j), sort_comp(L, -3, -1)) {
        if (j<l) luaL_error(L, "invalid order function for sorting");
        lua_pop(L, 1);
      }
      if (j<i) {
        lua_pop(L, 3);
        break;
      }
      set2(L, i, j);
    }
    lua_rawgeti(L, 1, u-1);
    lua_rawgeti(L, 1, i);
    set2(L, u-1, i);

    if (i-l < u-i) {
      j=l; i=i-1; l=i+2;
    }
    else {
      j=i+1; i=u; u=j-2;
    }
    auxsort(L, j, i);
  }
}         */

/*static int sort (lua_State *L) {
  int n = aux_getn(L, 1);
  luaL_checkstack(L, 40, "");
  if (!lua_isnoneornil(L, 2))
    luaL_checktype(L, 2, LUA_TFUNCTION);
  lua_settop(L, 2);
  auxsort(L, 1, n);
  return 0;
}                               */

/* }====================================================== */
/////////////////////////////////////////////////////////////////////////////

void copyTable(lua_State *L, int indSource, int indDest, int indMade);

	// Pousse une copie de la table  l'index indSource
	// La table  l'index indMade est l'ensemble des tables deja copiees
	// Verifie si la table n'avait pas deja ete copiee
static void copyTableNew(lua_State *L, int indSource, int indMade)
{
	// verifie si la table dans la liste des copies
	lua_pushvalue(L,indSource);
	lua_rawget(L,indMade);

	if(lua_isnil(L,-1)) // table inconnue
	{
		lua_pop(L,1);
		lua_newtable(L);	// nouvelle table
		copyTable(L,indSource,lua_gettop(L),indMade);
	}
}

	// Copie la table indSource dans indDest
	// Ne verifie pas si la table avait deja ete copiee
static void copyTable(lua_State *L, int indSource, int indDest, int indMade)
{
	if(indSource!=LUA_GLOBALSINDEX)
	{
		// place la nouvelle entree dans la liste
		lua_pushvalue(L,indSource);
		lua_pushvalue(L,indDest);
		lua_rawset(L,indMade);
	}

		// effectue la copie
	lua_pushnil(L);  // first key
	while(lua_next(L,indSource) != 0) // `key' is at index -2 and `value' at index -1
	{
		lua_pushvalue(L,-2);	// duplique la cl
		lua_insert(L,-2);

		if(lua_istable(L,-1))
		{
			copyTableNew(L, lua_gettop(L), indMade);
			lua_replace(L,-2);
		}
		lua_rawset(L,indDest);
	}
				
		// copie la metatable
	if(lua_getmetatable(L,-2))
	{
		copyTableNew(L, lua_gettop(L), indMade);
		lua_setmetatable(L,-3);
		lua_pop(L,1);
	}
}



void cplua_copytable(lua_State *L, int indSource, bool deep, int indDest)
{

	if(!deep)	// SHALLOW COPY
	{
          int taille= luaL_getn(L, 1)+1;
          lua_createtable(L,0,taille);
          indDest = lua_gettop(L);
             int i;
          for (i=1;i<=taille;i++) {
           lua_rawgeti(L, indSource, i);
           lua_rawseti(L, indDest, i);
          }
	return;
          

          }
        if(indDest==0)
	{
		lua_newtable(L);
		indDest = lua_gettop(L);
	}
	
	if(!deep)	// SHALLOW COPY
	{
		lua_pushnil(L);  /* first key */
		while(lua_next(L, indSource)) 
		{
			/* `key' is at index -2 and `value' at index -1 */
			lua_pushvalue(L,-2);
			lua_insert(L,-2);	// duplique la cle
			lua_rawset(L,indDest);	// retire la valeur et la copie de la cle, et les place dans la nouvelle table

			// il reste la cle pour continuer l'iteration
		}
	}
	else		// DEEP COPY
	{
		lua_newtable(L);	// liste des tables deja copiees

			// ne pas copier l'environnement global
		lua_pushvalue(L,LUA_GLOBALSINDEX);
		lua_pushvalue(L,-1);
		lua_rawset(L,-3);

		copyTable(L, indSource, indDest,  lua_gettop(L));
		lua_pop(L,1);
	}
}

/////////////////////////////////////////////////////////////////////////////

static int copyy(lua_State *L)
{
        luaL_checktype(L,1,LUA_TTABLE);
        static const char* opts[] = { "shallow", "deep", NULL };
        cplua_copytable(L, 1, luaL_checkoption(L, 2, "deep", opts),0);
        return 1;
}


static const luaL_Reg tab_funcs[] = {
 // {"concat", tconcat},
 // {"foreach", foreach},
 // {"foreachi", foreachi},
  {"getn", getn},
  {"maxn", maxn},
  {"insert", tinsert},
  {"remove", tremove},
  {"setn", setn},
  {"copy", copyy},
 // {"sort", sort},
  {NULL, NULL}
};


LUALIB_API int luaopen_table (lua_State *L) {
  luaL_register(L, LUA_TABLIBNAME, tab_funcs);
  return 1;
}

